/***************************************************************
 * Name:      EventsMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Stefano Smania (smania2000@libero.it)
 * Created:   2010-09-07
 * Copyright: Stefano Smania (http:\\www.frikosystem.net)
 * License:
 **************************************************************/

#include "EventsMain.h"


//(*InternalHeaders(EventsFrame)
#include <wx/intl.h>
#include <wx/string.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(EventsFrame)
const long EventsFrame::ID_BUTTON2 = wxNewId();
const long EventsFrame::ID_BUTTON1 = wxNewId();
const long EventsFrame::ID_TEXTCTRL1 = wxNewId();
//*)

CustomThread * MyThread=NULL;


BEGIN_EVENT_TABLE(EventsFrame,wxFrame)
    //(*EventTable(EventsFrame)
    //*)
END_EVENT_TABLE()

EventsFrame::EventsFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(EventsFrame)
    wxFlexGridSizer* FlexGridSizer2;
    wxBoxSizer* BoxSizer1;
    wxFlexGridSizer* FlexGridSizer1;

    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(219,176));
    BoxSizer1 = new wxBoxSizer(wxVERTICAL);
    FlexGridSizer2 = new wxFlexGridSizer(2, 1, 0, 0);
    FlexGridSizer1 = new wxFlexGridSizer(0, 2, 0, 0);
    Button2 = new wxButton(this, ID_BUTTON2, _("START"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    FlexGridSizer1->Add(Button2, 1, wxALL|wxALIGN_LEFT|wxALIGN_BOTTOM, 5);
    Button1 = new wxButton(this, ID_BUTTON1, _("STOP"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    Button1->Disable();
    FlexGridSizer1->Add(Button1, 1, wxALL|wxALIGN_LEFT|wxALIGN_BOTTOM, 5);
    FlexGridSizer2->Add(FlexGridSizer1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxSize(284,155), wxTE_MULTILINE, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    FlexGridSizer2->Add(TextCtrl1, 1, wxALL|wxALIGN_LEFT|wxALIGN_BOTTOM, 5);
    BoxSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_BOTTOM, 5);
    SetSizer(BoxSizer1);
    BoxSizer1->SetSizeHints(this);

    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&EventsFrame::OnButton2Click);
    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&EventsFrame::OnButton1Click);
    //*)

    Connect( wxID_ANY, E_MyEvent,MyEventHandler(EventsFrame::DoMyEvent), NULL, this );
}

EventsFrame::~EventsFrame()
{
    if(MyThread) MyThread->Delete();
}

void EventsFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void EventsFrame::OnButton2Click(wxCommandEvent& event)
{
    MyThread=new CustomThread(GetEventHandler());
    if(!MyThread) {TextCtrl1->AppendText(_("Error creating thread"));return;}
    if(MyThread->Create((unsigned int)0)!=wxTHREAD_NO_ERROR) // lancia il thread che parte in modalità “suspended”. Lo 0 indica di usare lo stack di default
    {
      delete MyThread;
      return;
    }
    MyThread->SetPriority(75); // setta la priorità del thread  (da 0 a 100 dove lo 0 indica la priorità minore.
    MyThread->Run(); // questo lancia il thread*/
    TextCtrl1->AppendText(_("Thread is running...\n"));
    Button2->Enable(false);
    Button1->Enable(true);
}

void EventsFrame::DoMyEvent(C_MyEvent &event )
{
    int ID=event.GetId();
    wxString MsgID=wxString::Format(wxT("%d"),ID);
    wxString Msg=event.GetText();
    TextCtrl1->AppendText(_("ID :")+MsgID+_(" - Message: ")+Msg+_("\n"));
    if(ID==ThreadFailure) TextCtrl1->AppendText(_("F A I L U R E\n"));
}


void EventsFrame::OnButton1Click(wxCommandEvent& event)
{
  if(MyThread) MyThread->Delete();
  delete MyThread;
  MyThread=NULL;
  Button2->Enable(true);
  Button1->Enable(false);
}
